var ParticleSettings = {
    data: null,

    init: function(data) {
        var self = this;
        self.data = data;

        self.show();
        self.initShow();

        self.setUID();
        self.setType();
        self.setLabel();
        self.setPosition();
        self.setRotation();
        self.setScale();
        self.setVisible();

        self.addEvents();
    },

    show: function() {
        $('.settings_root3').show();
        $('.settings_root2').hide();
        $('.settings_root1').hide();
        $('.settings_root0').hide();
    },
    hide: function() {
        $('.settings_root3').hide();
        $('.settings_root2').hide();
        $('.settings_root1').hide();
        $('.settings_root0').show();
    },

    initShow: function() {
        var self = this;
        var conf = getObjConf(self.type);


    },

    setUID: function(val) {
        var self = this;
        var uid = val? val : self.data.uid;
        self.uid = uid;
    },

    setType: function(val) {
        var self = this;
        var type = val? val : self.data.type;
        self.type = type;
    },

    setLabel: function(val) {
        var self = this;
        var label = val? val : self.data.label;
        self.label = label;

        objById('particle_label').value = self.label;
    },

    setVisible: function(val) {
        var self = this;
        var visible = val? val : self.data.visible;
        self.visible = visible;
        objById('particle_visible').checked = self.visible;
    },

    setPosition: function(val) {
        var self = this;
        var position = val? val : self.data.position;
        self.position = position;

        objById('particle_position_x').value = Number(self.position.x);
        objById('particle_position_y').value = Number(self.position.y);
        objById('particle_position_z').value = Number(self.position.z);
    },

    setRotation: function(val) {
        var self = this;
        var rotation = val? val : self.data.rotation;
        self.rotation = rotation;

        objById('particle_rotation_x').value = Number(self.rotation.x/Math.PI * 180);
        objById('particle_rotation_y').value = Number(self.rotation.y/Math.PI * 180);
        objById('particle_rotation_z').value = Number(self.rotation.z/Math.PI * 180);
    },

    setScale: function(val) {
        var self = this;
        var scale = val? val : self.data.scale;
        self.scale = scale;

        objById('particle_scale_x').value = Number(self.scale.x);
        objById('particle_scale_y').value = Number(self.scale.y);
        objById('particle_scale_z').value = Number(self.scale.z);
    },

    addEvents: function() {
        var self = this;

        objById('delete_particle_btn').onclick = self.onDeleteObject.bind(self);

        objById('particle_label').onchange = self.onUpdateLabel.bind(self);

        objById('particle_position_x').onchange = self.onUpdatePosition.bind(self);
        objById('particle_position_y').onchange = self.onUpdatePosition.bind(self);
        objById('particle_position_z').onchange = self.onUpdatePosition.bind(self);

        objById('particle_rotation_x').onchange = self.onUpdateRotation.bind(self);
        objById('particle_rotation_y').onchange = self.onUpdateRotation.bind(self);
        objById('particle_rotation_z').onchange = self.onUpdateRotation.bind(self);

        objById('particle_scale_x').onchange = self.onUpdateScale.bind(self);
        objById('particle_scale_y').onchange = self.onUpdateScale.bind(self);
        objById('particle_scale_z').onchange = self.onUpdateScale.bind(self);

        objById('particle_visible').onchange = self.onUpdateVisible.bind(self);
    },

    onDeleteObject: function(e ) {
        var self = this;
        AREditor.ee.trigger('delete_object_ws', [self.data]);
    },

    onUpdateLabel: function(e) {
        var self = this;
        var label = objById('particle_label').value;
        if(label != self.label) {
            self.label = label;
            AREditor.ee.trigger('set_label', [self.uid, self.label]);
        }
    },

    onUpdatePosition: function(e) {
        var self = this;
        var x = Number(objById('particle_position_x').value);
        var y = Number(objById('particle_position_y').value);
        var z = Number(objById('particle_position_z').value);

        if(self.position.x != x || self.position.y != y || self.position.z != z) {
            self.position.x = x;
            self.position.y = y;
            self.position.z = z;
            AREditor.ee.trigger('set_position', [self.uid, self.position]);
        }
    },

    onUpdateRotation: function(e) {
        var self = this;
        var x = Number(objById('particle_rotation_x').value)/180 * Math.PI;
        var y = Number(objById('particle_rotation_y').value)/180 * Math.PI;
        var z = Number(objById('particle_rotation_z').value)/180 * Math.PI;

        if(self.rotation.x != x || self.rotation.y != y || self.rotation.z != z) {
            self.rotation.x = x;
            self.rotation.y = y;
            self.rotation.z = z;
            AREditor.ee.trigger('set_rotation', [self.uid, self.rotation]);
        }
    },

    onUpdateScale: function(e) {
        var self = this;
        var x = Number(objById('particle_scale_x').value);
        var y = Number(objById('particle_scale_y').value);
        var z = Number(objById('particle_scale_z').value);

        if(self.scale.x != x || self.scale.y != y || self.scale.z != z) {
            self.scale.x = x;
            self.scale.y = y;
            self.scale.z = z;
            AREditor.ee.trigger('set_scale', [self.uid, self.scale]);
        }
    },

    onUpdateVisible: function(e) {
        var self = this;
        self.visible = e.target.checked;

        AREditor.ee.trigger('set_visible', [self.uid, self.visible]);
    },
};